package lib::NewsFeed;

use lib::Config;
use lib::Header;
use lib::NNTP;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(newsfeed);

require $config;

sub newsfeed {
    my $art = shift;
    my @artarr = split /\n/, $art;
    my $head = fetch_header($art);
    my @path = split /!/, $head->{path};

    grep s/$/\n/, @artarr;

    return 0 unless $head->{'message-id'};

    for my $s (keys %main::site) {
	next if $main::site{$s}->{mode} !~ /w/;
	next if grep /^$main::site{$s}->{pathhost}$/, @path;

	my $group = $main::site{$s}->{group};
	$group =~ s/\./\\./g;
	$group =~ s/\*/.*/g;
	my @grouppat = split /,/, $group;
	my $pos = join '|', grep /^[^!]/, @grouppat;
	my $neg = join '|', grep s/^!//, @grouppat;

	next unless $pos and $head->{newsgroups} =~ /^($pos)$/;
	next if $neg and $head->{newsgroups} =~ /^($neg)$/;

	my $nntp = newNNTP($main::site{$s}->{host}, $main::site{$s});
	$nntp->slave();

	if ($nntp->ihave($head->{'message-id'})) {
	    $nntp->datasend(@artarr);
	    $nntp->dataend();
	} elsif ($nntp->postok) {
	    # We are not allowed to use IHAVE :-(
	    unless ($nntp->head($head->{'message-id'})) {
		$nntp->post(@artarr);
	    }
	}
    }

    return 0;
}

1;

# end
